#define __OCICPP_INTERNAL_USE_
#include "OraLob.h"


OraLob::OraLob(OCIEnv *envhp,OCIError *errhp,OCIParam *param,OCISvcCtx *svc,ub2 lob_type,int rows): 
				OraType(envhp,errhp,param,lob_type,rows),lob(0),svchp(svc),type(lob_type)
{
	ReqType=lob_type;
	size=0;
	lob=(OCILobLocator **)calloc(nRows,sizeof(OCILobLocator *));
	for(int i=0;i<nRows;i++) {
		if(OCIDescriptorAlloc((void *)envhp,(void **)&lob[i],OCI_DTYPE_LOB,0,0)!=OCI_SUCCESS) {
			throw new OraError("OCICPPLIB: Cannot make new LOB: Handle Allocation failed",OCICPPERROR);
		}
	}
}

OraLob::~OraLob() {
	for(int i=0;i<nRows;i++) {
		OCIDescriptorFree(lob[i],OCI_DTYPE_LOB);
	}
	free(lob);
	OCIHandleFree(definehp,OCI_HTYPE_DEFINE);
}

void OraLob::define(OCIStmt *stmt,int col) {
	 CHECKERR(err, OCIDefineByPos(stmt,&definehp, err, col+1, lob, -1,ReqType,
	                                (dvoid *) null, 0, (ub2 *)0, OCI_DEFAULT)); 
}

void OraLob::getCLOB(Lob &ulob,int row) {
	ulob.init(svchp,lob[row],err,CLOB,CACHE_OFF);
}

void OraLob::getBLOB(Lob &ulob,int row) {
	ulob.init(svchp,lob[row],err,BLOB,CACHE_OFF);
}

void OraLob::getStr(string &str,int row) {
	str.assign(typeName);
}