#define __OCICPP_INTERNAL_USE_
#include "OraNumber.h"

OraNumber::OraNumber(OCIEnv *envhp,OCIError *errhp,OCIParam *paramd,ub2 type,int rows): 
	OraType(envhp,errhp,paramd,type,rows),data(0) 
{
	ub2 prec; /* There's a bug in documentation it should be ub2 */
	ReqType=SQLT_STR;
	OCIAttrGet((dvoid *) paramd,OCI_DTYPE_PARAM,(dvoid *) &prec,(ub4 *) 0,(ub4) OCI_ATTR_PRECISION,errhp);
	if(!prec) size=255;
	else size=(unsigned)prec;
	data=(char *)calloc((size+1)*nRows,sizeof(char));
	DEBUG(DLEV_DEBUG,"Size=%d\n",size);
}

OraNumber::~OraNumber() {
	free(data);
	OCIHandleFree(definehp,OCI_HTYPE_DEFINE);	
}

void OraNumber::define(OCIStmt *stmt,int col) {
	CHECKERR(err, OCIDefineByPos(stmt,&definehp, err, col+1, data, size+1,ReqType,
	                               (dvoid *) null, 0, (ub2 *)0, OCI_DEFAULT));	
}
	
void OraNumber::getStr(string &str,int row) {
	if(data) str.assign(data+(size+1)*row);
	else throw new OraError("OCICPPLIB: Cannot getStr: Not fetched yet",OCICPPERROR);
}

void OraNumber::getInt(int &val,int row) {
	if(data) {
		val=atoi(data+(size+1)*row);
		return;
	} else throw new OraError("OCICPPLIB: Cannot getInt: Not fetched yet",OCICPPERROR);
}

void OraNumber::getDouble(double &val,int row) {
	if(data) {
		val=atof(data+(size+1)*row);
		return;
	} else throw new OraError("OCICPPLIB: Cannot getDouble: Not fetched yet",OCICPPERROR);
}


		

	