#define __OCICPP_INTERNAL_USE_
#include "OraRefCur.h"


OraRefCur::OraRefCur(OCIEnv *envhp,OCIError *errhp,OCIParam *paramd,ub2 type,int rows) :
			OraType(envhp,errhp,paramd,type,rows),stmthp(0)
{
	ReqType=SQLT_RSET;
	size=0;
	stmthp=(OCIStmt **)calloc(nRows,sizeof(OCIStmt *));
	for(int i=0;i<nRows;i++) {
		if(OCIHandleAlloc((dvoid *)env,(dvoid **)&stmthp[i],OCI_HTYPE_STMT,(size_t) 0, (dvoid **) 0)!=OCI_SUCCESS) {
			throw new OraError("OCICPPLIB: OraRefCur: HandleAlloc failed",OCICPPERROR);
		}
	}
	DEBUG(DLEV_DEBUG,"RefCursor created\n");
}

OraRefCur::~OraRefCur() {
	for(int i=0;i<nRows;i++) {
		OCIHandleFree(stmthp[i],OCI_HTYPE_STMT);
	}
	free(stmthp);
	OCIHandleFree(definehp,OCI_HTYPE_DEFINE);
}

void OraRefCur::getStr(string &str,int row) {
	str.assign("REFCURSOR");
}

void OraRefCur::define(OCIStmt *stmt,int col) {
	CHECKERR(err,OCIDefineByPos(stmt, &definehp, err,col+1, stmthp, (sb4)0, ReqType, 
								   (dvoid *)null, 0, 0, OCI_DEFAULT));
}
					
OCIStmt *OraRefCur::getStmt(int row) {
	return stmthp[row];
}								   
	
	